--Simple example
--	50 Multicolored balls float around.
--	They collide off each other, and off the walls.
--
--Author: MrTrick
include graphics.e
include vector.e 
without warning
-------------------------------------------------------------------------------
if graphics_mode(259) then abort(1) end if
-------------------------------------------------------------------------------
sequence Balls, Obstacles, tempBalls
--Set a boundary around the outside of the screen
Obstacles = newLines({{0,0},{0,600},{800,600},{800,0},{0,0}},{0,0},1) 


--Create 50 balls in random positions, with random velocities
Balls = {}
for a = 1 to 50 do
    Balls &= {newBall(rand({700,500})+50,10,rand({10,10})-5, 1)}
end for
-------------------------------------------------------------------------------
while get_key() = -1 do
    tempBalls = moveBalls(Balls,        
                          Obstacles, 
                          {0,0},        --gravity is an {x,y} quantity. Gravity can be sideways if you choose.
                          0)            --Coefficient of friction. Set to 0 for no friction, 0.3 for water, and 0.5 for treacle* (Empirical values :oP)
    for a = 1 to length(Balls) do draw_ball(BLACK, 1, Balls[a]) end for
    Balls = tempBalls
    for a = 1 to length(Balls) do draw_ball(a+30, 1, Balls[a]) end for
end while
-------------------------------------------------------------------------------