--Example 2
--	15 Multicolored balls drop down through pegs
--	They collide off each other, and off the pegs.
--  Example 5 is similar, except that it uses win32lib
--Author: MrTrick
include graphics.e
include vector.e 
without warning

-------------------------------------------------------------------------------
if graphics_mode(259) then abort(1) end if

-------------------------------------------------------------------------------
sequence Balls, Obstacles, tempBalls
Obstacles = {}
for b = 1 to 10 do
for a = 1 to 8 do
    Obstacles &= {newBall({80*b+40*(not remainder(a,3))-50,70*a-10} + rand({20,20})-10,10, {0,0},0.5)}
    end for
end for


--Create 15 balls along the top of the screen
Balls = {}
for a = 1 to 15 do
    Balls &= {newBall({a*50,10},10,{0,0}, 0.5)}
end for
-------------------------------------------------------------------------------

for a = 1 to length(Obstacles) do draw_ball(9, 1, Obstacles[a]) end for
while get_key() = -1 do
    tempBalls = checkBounds(Balls, {0,0}, {800,600})
    tempBalls = moveBalls(tempBalls,        
                          Obstacles, 
                          {0,2},        --gravity is an {x,y} quantity. Gravity can be sideways if you choose.
                          0)            --Coefficient of friction. Set to 0 for no friction, 0.3 for water, and 0.5 for treacle* (Empirical values :oP)
    for a = 1 to length(Balls) do draw_ball(BLACK, 1, Balls[a]) end for
    Balls = tempBalls                   
    for a = 1 to length(Balls) do draw_ball(2*a+40, 1, Balls[a]) end for
end while
-------------------------------------------------------------------------------